import { __rest } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import Row from 'react-bootstrap/Row';
import Col from 'react-bootstrap/Col';
import Container from 'react-bootstrap/Container';
import { getTemplate, getUiOptions, } from '@rjsf/utils';
export default function ArrayFieldTemplate(props) {
    const { canAdd, disabled, idSchema, uiSchema, items, onAddClick, readonly, registry, required, schema, title } = props;
    const uiOptions = getUiOptions(uiSchema);
    const ArrayFieldDescriptionTemplate = getTemplate('ArrayFieldDescriptionTemplate', registry, uiOptions);
    const ArrayFieldItemTemplate = getTemplate('ArrayFieldItemTemplate', registry, uiOptions);
    const ArrayFieldTitleTemplate = getTemplate('ArrayFieldTitleTemplate', registry, uiOptions);
    // Button templates are not overridden in the uiSchema
    const { ButtonTemplates: { AddButton }, } = registry.templates;
    return (_jsx("div", { children: _jsx(Row, Object.assign({ className: 'p-0 m-0' }, { children: _jsxs(Col, Object.assign({ className: 'p-0 m-0' }, { children: [_jsx(ArrayFieldTitleTemplate, { idSchema: idSchema, title: uiOptions.title || title, schema: schema, uiSchema: uiSchema, required: required, registry: registry }), _jsx(ArrayFieldDescriptionTemplate, { idSchema: idSchema, description: uiOptions.description || schema.description, schema: schema, uiSchema: uiSchema, registry: registry }), _jsxs(Container, Object.assign({ fluid: true, className: 'p-0 m-0' }, { children: [items &&
                                items.map((_a) => {
                                    var { key } = _a, itemProps = __rest(_a, ["key"]);
                                    return (_jsx(ArrayFieldItemTemplate, Object.assign({}, itemProps), key));
                                }), canAdd && (_jsx(Container, Object.assign({ className: '' }, { children: _jsxs(Row, Object.assign({ className: 'mt-2' }, { children: [_jsx(Col, { xs: 9 }), _jsx(Col, Object.assign({ xs: 3, className: 'py-4 col-lg-3 col-3' }, { children: _jsx(AddButton, { className: 'array-item-add', onClick: onAddClick, disabled: disabled || readonly, uiSchema: uiSchema, registry: registry }) }))] })) })))] }), `array-item-list-${idSchema.$id}`)] })) })) }));
}
//# sourceMappingURL=ArrayFieldTemplate.js.map